#!/usr/bin/perl

use strict;
use Fcntl qw(:flock);

#===============================================================================
# counter.cgi: ӂ̃ANZXJE^ for perl
# The latest version is here: http://confetto.s31.xrea.com/
#===============================================================================
# Copyright (c) 2004-2007 confetto. <confetto@s31.xrea.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#===============================================================================
my $rcsid = q$Id: counter.cgi,v 1.3 2007/11/08 19:06:33 confetto Exp $;

#===============================================================================
# ݒ
#===============================================================================

## JEgl̕\
# RlŎw肵܂B0̏ꍇ͌s܂B
my $FIGURES = 6;

## dJEgh~@\
# gꍇ1B̏ꍇAxJEgzXg͂̓̐[24܂ŃJEg
# ܂B
my $COUNT_UNIQUE = 0;

## JEgȂANZX
# ''̒ɁApXy[Xŋ؂ĕwł܂BOvŃJEgȂȂ
# ܂B

    ## JEgȂIPAhX
    my @DENY_ADDRS = qw'';

    ## JEgȂ[U[G[WFg
    my @DENY_AGENTS = qw'Another_HTML-lint W3C_Validator';

## JEgl̊
# JEgliŕ\邩A2i36i܂Ŏw\łB11iȏ
# ͐ƃAt@xbg26gpĕ\܂BGIFJE^gṕA
# ̉摜(a.gif`z.gif)KvɂȂ܂B
my $NUMBER_BASE = 10;

## ֘At@C̃pX
my $DATA_FILE  = './counter.dat';   # JEglL^t@C
my $ADDR_FILE  = './address.dat';   # IPAhXL^t@C
my $GIFCAT_LIB = './gifcat.pl';     # GIFt@CACu
my $IMAGES     = './images/%s.gif'; # JE^p摜t@C

#===============================================================================
# [`
#===============================================================================

open FD, "+< $DATA_FILE" or error("Can't open $DATA_FILE: $!");
eval { flock FD, LOCK_EX; };
my $count = <FD>;
if (is_valid_access()) {
	$count++;
	seek FD, 0, 0;
	print FD $count;
}
close FD;

$count = dec2base($count, $NUMBER_BASE);
$count = sprintf "%0${FIGURES}s", $count;

my $mode = shift @ARGV;

if ($mode eq 'gif') {
	print_header('image/gif');
	print_gif_counter($count);
} elsif ($mode eq 'js') {
	print_header('text/javascript');
	printf 'document.write("%s")', uc $count;
} else {
	print_header('text/plain');
	print uc $count;
}

#===============================================================================
# Tu[`
#===============================================================================

#
# JEgAbvĂǂ
#
sub is_valid_access {
	foreach (@DENY_ADDRS) {
		return 0 if index($ENV{REMOTE_ADDR}, $_) == 0;
	}
	foreach (@DENY_AGENTS) {
		return 0 if index($ENV{HTTP_USER_AGENT}, $_) == 0;
	}
	return 1 if !$COUNT_UNIQUE;
	return 1 if is_first_access();
	return 0;
}

#
# ̃zXg͍߂Ă
#
sub is_first_access {
	$ENV{TZ} = 'JST-9';
	my $mtime = (stat $ADDR_FILE)[9];
	my $mdate = sprintf "%04d%02d%02d", (localtime $mtime)[5..3];
	my $ndate = sprintf "%04d%02d%02d", (localtime)[5..3];

	if ($mdate eq $ndate) {
		open IN, $ADDR_FILE or error("Can't open $ADDR_FILE: $!");
		while (<IN>) {
			chomp;
			return if $ENV{REMOTE_ADDR} eq $_;
		}
		close IN;
	} else {
		open OUT, "> $ADDR_FILE"
			or error("Can't open $ADDR_FILE: $!");
		close OUT;
	}
	open  OUT, ">> $ADDR_FILE" or error("Can't open $ADDR_FILE: $!");
	print OUT $ENV{REMOTE_ADDR}, "\n";
	open  OUT;
	return 1;
}

#
# GIFJE^o͂
#
sub print_gif_counter {
	my($count_str) = @_;
	my @files = map sprintf($IMAGES, $_), split(/|/, $count_str);

	require $GIFCAT_LIB;
	binmode STDOUT;
	print gifcat::gifcat(@files);
}

#
# HTTPX|Xwb_o͂
#
sub print_header {
	my($type) = @_;

	print "Cache-Control: no-cache\n";
	print "Content-Type: $type\n";
	print "\n";
}

#
# G[o͂ďI
#
sub error {
	my($message) = @_;

	print_header('text/plain');
	print "[ERROR: $message]";
	die $message;
}

#
# 10iniɕϊĕԂ
#  2i36i܂ŁB
#
sub dec2base {
	my($number, $dignum) = @_;
	my @digits = (0..9, 'a'..'z');
	my $result = '';

	return $number if $dignum == 10 or $dignum < 2 or $dignum > 36;
	while ($number > 0) {
		$result = $digits[$number % $dignum] . $result;
		$number = int($number / $dignum);
	}
	return length $result ? $result : $digits[0];
}
